__kernel void gradientKernel(__global const float* x, __global const float* d, __global const int* samples, __global const int* sampleLen, __global const int* outputLen, __global const float* netWeights, __global const int* netStruct, __global const int* netTypes, __global const int* netLayersCount, __global const int* netSize, __global float* netOutputs, __global float* netGradient) {
		//layers index
		int l = 0;
		//neurons index
		int n = 0;
		//previous layer neurons
		int p = 0;
		//weights index
		int w = 0;
		
		int v=0;
		//help indexes
		int i = 0;
		int offset = 0;
		float sum=0;
		//forward propagation
		v=get_global_id(0);
		if(v>=*samples)
			return;

		w=0;
		for(l=0; l<*netLayersCount; l++) {
			for(n=0; n<netStruct[l+1]; n++) {
				sum = netWeights[w];
				w++;
				for(p=0; p<netStruct[l]; p++) {
					if(l==0) {
						sum+=netWeights[w]*x[v*(*sampleLen)+p];
					} else {
						sum+=netWeights[w]*netGradient[v*(*netSize)+offset+p*(netStruct[l-1]+1)];
					}
					w++;
				}
				//sigmoidal neurons
				if(netTypes[l]==2)
					sum = (float)(1/(1+exp((-1)*1*sum)));
				else if (netTypes[l]==3)
					sum = (float)2.0/(1+exp(-2.0*sum))-1;
				for(i=w-1-netStruct[l]; i<w; i++)
					netGradient[v*(*netSize)+i]=sum;
				if(l==(*netLayersCount)-1)
					netOutputs[v*(*outputLen)+n]=sum;
			}
			if(l>0)
				offset+=(netStruct[l-1]+1)*netStruct[l];
		}
		float temp=0;
		//back propagation
		if ((*netLayersCount) == 1) {
			//output layer
			l=(*netLayersCount)-1;
			w=(*netSize)-1;
			for(n=netStruct[l+1]-1; n>=0; n--) {
				sum=netOutputs[v*(*outputLen)+n]-d[v*(*outputLen)+n];
				for(p=netStruct[l]-1; p>=0; p--) {
					if(netTypes[l]==2)
						netGradient[v*(*netSize)+w] = x[v*(*sampleLen)+p]*sum*1*(1-netGradient[v*(*netSize)+w])*netGradient[v*(*netSize)+w];
					else if(netTypes[l]==3)
						netGradient[v*(*netSize)+w] = x[v*(*sampleLen)+p]*sum*(1-netGradient[v*(*netSize)+w]*netGradient[v*(*netSize)+w]);
					else
						netGradient[v*(*netSize)+w] = x[v*(*sampleLen)+p]*sum;
					w--;
				}
				if(netTypes[l]==2)
					netGradient[v*(*netSize)+w] = (sum*1*(1-netGradient[v*(*netSize)+w])*netGradient[v*(*netSize)+w]);
				else if(netTypes[l]==3)
					netGradient[v*(*netSize)+w] = (sum*1*(1-netGradient[v*(*netSize)+w]*netGradient[v*(*netSize)+w]));

				else
					netGradient[v*(*netSize)+w] = sum;
					w--;
			}
			return;
		}
		//output layer
		l=(*netLayersCount)-1;
		w=(*netSize)-1;
		for(n=1; n<=netStruct[l+1]; n++) {
			sum=netOutputs[v*(*outputLen)+netStruct[l+1]-n]-d[v*(*outputLen)+netStruct[l+1]-n];
			for(p=1; p<=netStruct[l]; p++) {
				if(netTypes[l]==2)
					netGradient[v*(*netSize)+w] = netGradient[(v+1)*(*netSize)-netStruct[l+1]*(netStruct[l]+1)-(netStruct[l-1]+1)*p]*sum*1*(1-netGradient[v*(*netSize)+w])*netGradient[v*(*netSize)+w];
				else if(netTypes[l]==3)
					netGradient[v*(*netSize)+w] = netGradient[(v+1)*(*netSize)-netStruct[l+1]*(netStruct[l]+1)-(netStruct[l-1]+1)*p]*sum*1*(1-netGradient[v*(*netSize)+w]*netGradient[v*(*netSize)+w]);
				else
					netGradient[v*(*netSize)+w] = netGradient[(v+1)*(*netSize)-netStruct[l+1]*(netStruct[l]+1)-(netStruct[l-1]+1)*p]*sum;
				w--;
			}
			if(netTypes[l]==2)
				netGradient[v*(*netSize)+w] = sum*1*(1-netGradient[v*(*netSize)+w])*netGradient[v*(*netSize)+w];
			else if(netTypes[l]==3)
				netGradient[v*(*netSize)+w] = sum*1*(1-netGradient[v*(*netSize)+w]*netGradient[v*(*netSize)+w]);
			else
				netGradient[v*(*netSize)+w] = sum;
			w--;
		}
		offset=0;
		for(l=(*netLayersCount)-1; l>0; l--) {
			for(i=netStruct[l]; i>0; i--)  {
				sum=0;
		    	for(n=1; n<=netStruct[l+1]; n++)  {
		    		sum+=netGradient[(v+1)*(*netSize)-offset-n*(netStruct[l]+1)]*netWeights[(*netSize)-offset-n*(netStruct[l]+1)+i];
		    	}
		    	//first hidden layer
		    	if(l-1==0) {
		    		for(p=netStruct[l-1]-1; p>=0; p--)  {
		    			if(netTypes[l-1]==2)
		    				netGradient[v*(*netSize)+w] = sum*x[v*(*sampleLen)+p]*1*(1-netGradient[v*(*netSize)+w])*netGradient[v*(*netSize)+w];
		    			else if(netTypes[l-1]==3)
		    				netGradient[v*(*netSize)+w] = sum*x[v*(*sampleLen)+p]*1*(1-netGradient[v*(*netSize)+w]*netGradient[v*(*netSize)+w]);
		    			else
		    				netGradient[v*(*netSize)+w] = sum*x[v*(*sampleLen)+p];
		    			w--;
		    		}
		    	} else {
		    		for(p=1; p<=netStruct[l-1]; p++)  {
		    			if(netTypes[l-1]==2)
		    				netGradient[v*(*netSize)+w] = netGradient[(v+1)*(*netSize)-(offset+netStruct[l+1]*(netStruct[l]+1))-netStruct[l]*(netStruct[l-1]+1)-(netStruct[l-2]+1)*p]*sum*1*(1-netGradient[v*(*netSize)+w])*netGradient[v*(*netSize)+w];
		    			else if(netTypes[l-1]==3)
		    				netGradient[v*(*netSize)+w] = netGradient[(v+1)*(*netSize)-(offset+netStruct[l+1]*(netStruct[l]+1))-netStruct[l]*(netStruct[l-1]+1)-(netStruct[l-2]+1)*p]*sum*1*(1-netGradient[v*(*netSize)+w]*netGradient[v*(*netSize)+w]);
		    			else
		    				netGradient[v*(*netSize)+w] = netGradient[(v+1)*(*netSize)-(offset+netStruct[l+1]*(netStruct[l]+1))-netStruct[l]*(netStruct[l-1]+1)-(netStruct[l-2]+1)*p]*sum;
		    			w--;
		    		}
		    	}
		    	if(netTypes[l-1]==2)
					netGradient[v*(*netSize)+w] = sum*1*(1-netGradient[v*(*netSize)+w])*netGradient[v*(*netSize)+w];
		    	else if(netTypes[l-1]==3)
		    		netGradient[v*(*netSize)+w] = sum*1*(1-netGradient[v*(*netSize)+w]*netGradient[v*(*netSize)+w]);

				else
					netGradient[v*(*netSize)+w] = sum;
				w--;
			}
			offset+=netStruct[l+1]*(netStruct[l]+1);
		}
	}
